admins = ['STEAM_ID_LAN', 'YOUR STEAMID HERE', 'Another...', 'AND SO ON']

import es, cfglib, popuplib, playerlib, gamethread, cPickle, os.path, random, services, time

info = es.AddonInfo()
info.name     = "Warmd"
info.version  = "3.3-ESAM-Release"
info.url      = "http://addons.eventscripts.com/addons/view/warmod"
info.basename = "warmod"
info.author   = "DanielB aka Master"
# And a HUGE Thanks to DHack, who helped me to test and debug Pug Mode
es.ServerVar('warmod_ver', info.version, 'What version of DanielBs Warmod is running').makepublic()

config = cfglib.AddonCFG(es.getAddonPath('warmod') + '/settings.cfg')
config.text('#################################################################')
config.text('#                 WarMod Setting and configuration')
config.text('#################################################################\n\n')

max_rounds = config.cvar('wm_maxrounds', 15, 'Number of rounds before team swap')
win_rounds = config.cvar('wm_winrounds', 16, 'Number of rounds to win')
auto_pass = config.cvar('wm_autopass', 0, 'Automatically manage Server password (1 = yes, 0 = no)')
pass_on = config.cvar('wm_onpass', 'war123', 'The password of the server when a war is active')
pass_off = config.cvar('wm_offpass', '', 'The password of the server when a war is not active. leave blank for no password')
supress = config.cvar('wm_supglobal', 1, 'Stop Global chat during a war (only if alive)')
save_result = config.cvar('wm_saveresult', 1, 'Save the result of the most recent war (for use with !result command)')
objective_points = config.cvar('wm_objective_points', 1, 'Will players get points for objectives? (explode, defuse) (1=yes,0=no)')
pug_mode = config.cvar('wm_pugmode', 0, 'Automatically start a war when there are 5 players on each team? (1=yes,0=no)')
ragdolls = config.cvar('wm_ragdolls', 0, 'Remove peoples bodies after they die? (1=yes,0=no)')
source_tv = config.cvar('wm_sourcetv', 0, 'Automatically record matches via Source TV (1=yes,0=no)')
#ot_cash = config.cvar('wm_otcash', 0, 'Give Players $10000 at the start of OT? (1=yes,0=no)')
autocfg = config.cvar('wm_autocfg', 1, 'Automatically Execute war config and server config?')
precfg = config.cvar('wm_warcfg', 'war.cfg', 'Name of war config file(in cstrike/cfg folder)')
postcfg = config.cvar('wm_servercfg', 'server.cfg', 'Name of server config file(in cstrike/cfg folder)')
config.write()

data = {'active':0, 'mode':'norm', 'rActive':0,'rcount':0,'ot':0,
'team1': {'name':'Team 1', 'score':0},
'team2': {'name':'Team 2', 'score':0}}

pug_active = 0

players = {}
result = {}
dotr = popuplib.create('dotr')
isAuthed = None

def load():
    global players
    config.execute()
    es.addons.registerSayFilter(chatter)
    es.regclientcmd('war', 'warmod/start', 'Start a war!')
    es.regclientcmd('war_force', 'warmod/force', 'Force All players to ready themselves')
    es.regclientcmd('war_cancel', 'warmod/cancel', 'Cancel Current War')
    es.regcmd('war', 'warmod/startit', 'Start a war!')
    es.regcmd('war_force', 'warmod/forceit', 'Force All players to ready themselves')
    es.regcmd('war_cancel', 'warmod/cancelit', 'Cancel Current War')
    for i in playerlib.getUseridList('#all,#human'):
        if not players.has_key(str(i)):
            players[str(i)] = 0
    loadresult()
    for i in ['wm_maxrounds','wm_maxrounds','wm_maxrounds','wm_onpass','wm_offpass','wm_supglobal','wm_saveresult','wm_objective_points','wm_pugmode']:
        es.flags('add', 'notify', i)
    setup_auth()
    msg('v%s Loaded!'%info.version)

def player_death(ev):
    if int(ragdolls):
        es.delayed(0.1, 'es_fire %s cs_ragdoll kill'%ev['userid'])

def playerCount():
    return (len(playerlib.getUseridList('#t,#human')), len(playerlib.getUseridList('#ct,#human')))

def loadresult():
    global result
    if int(save_result):
        loc = es.getAddonPath('warmod') + '/result.db'
        if os.path.isfile(loc):
            a = file(loc, 'rb')
            result = cPickle.load(a)
            a.close()
        else:
            msg('An error was encountered loading previous scores')
            msg('No such file:')
            msg(loc)
            msg('Default values will be applied')
            result = {'winner':'Winner', 'looser':'Looser', 'wscore':15, 'lscore':15}

def saveresult():
    loc = es.getAddonPath('warmod') + '/result.db'
    a = file(loc, 'wb')
    cPickle.dump(result, a)
    a.close()

def set_result(team):
    global result
    if int(save_result):
        winner = 'team1' if team == 1 else 'team2'
        looser = 'team2' if team == 1 else 'team1'
        result = {'winner':data[winner]['name'], 'looser':data[looser]['name'], 'wscore':data[winner]['score'], 'lscore':data[looser]['score']}
        saveresult()

def player_activate(ev):
    players[ev['userid']] = 0
    if data['rActive']:
        gen_dotr()

def player_disconnect(ev):
    del players[ev['userid']]
    if data['rActive']:
        gen_dotr()

def msg(text):
    es.msg('#multi', '#green[WarMod]#lightgreen ' + text)
    
def tell(userid, text):
    es.tell(userid, '#multi', '#green[WarMod]#lightgreen ' + text)
    
def cash(userid, name, amount):
    es.tell(userid, '#multi', '#green[$$]#lightgreen %s #default>> #lightgreen$%s'%(name, amount))

def unload():
    es.addons.unregisterSayFilter(chatter)
    msg('Unloaded!')
    
def round_end(ev):
    global data, pug_active
    if data['active']:
        if not data['ot']:
            if ev['reason'] not in ['10', '16']:
                if ev['winner'] == '2':
                    if data['rcount'] < max_rounds:
                        data['team1']['score'] += 1
                    else:
                        data['team2']['score'] += 1
                elif ev['winner'] == '3':
                    if data['rcount'] < max_rounds:
                        data['team2']['score'] += 1
                    else:
                        data['team1']['score'] += 1
            data['rcount'] += 1
            say_score()
        
            if data['rcount'] == max_rounds:
                data['active'] = 0
                msg('End of part 1 - Teams will now be swapped')
                gamethread.delayed(3, swap_teams)
                reset_players()
                gamethread.delayed(3.5, gen_dotr)
            elif data['team1']['score'] == int(win_rounds):
                msg('%s Wins!'%data['team1']['name'])
                set_result(1)
                stoptv()
                reset_data()
                if int(auto_pass):
                    es.server.queuecmd('sv_password "%s"'%pass_off)
                doCFG(str(postcfg))
            elif data['team2']['score'] == int(win_rounds):
                msg('%s Wins!'%data['team2']['name'])
                set_result(2)
                stoptv()
                reset_data()
                if int(auto_pass):
                    es.server.queuecmd('sv_password "%s"'%pass_off)
                doCFG(str(postcfg))
            elif data['team1']['score'] == data['team2']['score'] == (win_rounds-1):
                msg('%s-all Lock! Overtime will now begin!'%(win_rounds-1))
                data['ot'] = 1
                data['mode'] = 'ot'
                gamethread.delayed(3, reset_data)
                gamethread.delayed(3, reset_players)
                gamethread.delayed(3.5, gen_dotr)
                
                
        elif data['ot']:
            if ev['reason'] not in ['10', '16']:
                if ev['winner'] == '2':
                    if data['rcount'] < 3:
                        data['team1']['score'] += 1
                    else:
                        data['team2']['score'] += 1
                else:
                    if data['rcount'] < 3:
                        data['team2']['score'] += 1
                    else:
                        data['team1']['score'] += 1
            data['rcount'] += 1
            say_score()
            if data['rcount'] == 3:
                data['active'] = 0
                msg('End of part 1 - Teams will now be swapped')
                gamethread.delayed(3, swap_teams)
                reset_players()
                gamethread.delayed(3.5, gen_dotr)
            if data['team1']['score'] == 4:
                msg('%s Wins!'%data['team1']['name'])
                set_result(1)
                stoptv()
                reset_data()
                if int(auto_pass):
                    es.server.queuecmd('sv_password "%s"'%pass_off)
                doCFG(str(postcfg))
            elif data['team2']['score'] == 4:
                msg('%s Wins!'%data['team2']['name'])
                set_result(2)
                stoptv()
                reset_data()
                if int(auto_pass):
                    es.server.queuecmd('sv_password "%s"'%pass_off)
                doCFG(str(postcfg))
            if data['team1']['score'] == data['team2']['score'] == 3:
                msg('3-all Lock! Overtime will now begin!')
                
    #PUG!
    if int(pug_mode):
        t, ct = playerCount()
        if pug_active:
            if (t < 5 or ct < 5):
                msg('Too little players to continue Pug!')
                msg('Pug will now be ended')
                reset_data()
                stoptv()
                pug_active = 0
                if int(auto_pass):
                    es.server.queuecmd('sv_password "%s"'%pass_off)
                doCFG(str(postcfg))
        else:
            if (t == 5 and ct == 5):
                msg('a 5v5 Pug will now start!')
                reset_data()
                reset_players()
                for i in players:
                    es.changeteam(i, 1)
                get5()
                gen_dotr()
                pug_active = 1
                doCFG(str(precfg))

def get5():
    players = playerlib.getUseridList('#spec,#human')
    for i in range(0,5):
        a = random.choice(players)
        es.changeteam(a, 2)
        players.remove(a)
    for i in players:
        es.changeteam(i, 3)
    msg('Teams have been randomised!')
    
            

def swap_teams():
    t = playerlib.getUseridList('#t,#human')
    ct = playerlib.getUseridList('#ct,#human')
    for i in t:
        es.changeteam(i, 3)
    for i in ct:
        es.changeteam(i, 2)

def reset_players():
    global players
    for i in players:
        players[i] = 0

def say_score():
    string = 'End of Round %s. '%data['rcount']
    if data['team1']['score'] == data['team2']['score']:
        string += 'Teams are tied at %s all'%data['team1']['score']
    elif data['team1']['score'] > data['team2']['score']:
        string += '%s leads %s-%s'%(data['team1']['name'], data['team1']['score'],data['team2']['score'])
    else:
        string += '%s leads %s-%s'%(data['team2']['name'], data['team2']['score'],data['team1']['score'])
    msg(string)
    
def round_start(ev):
    if data['active']:
        pl = playerlib.getUseridList('#t,#human')
        for i in pl:
            name = es.getplayername(i)
            amount = es.getplayerprop(i, "CCSPlayer.m_iAccount")
            for j in pl:
                cash(j, name, amount)
        pl = playerlib.getUseridList('#ct,#human')
        for i in pl:
            name = es.getplayername(i)
            amount = es.getplayerprop(i, "CCSPlayer.m_iAccount")
            for j in pl:
                cash(j, name, amount)
        
def cashControl():
    if int(ot_cash):
        if data['mode'] == 'ot':
            if data['rcount'] == 0:
                for i in playerlib.getPlayerList('#alive'):
                    i.set('cash', 10000)

def start():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if auth(steam):
        startit()
    else:
        es.cexec(userid, 'echo "You are not authorised!"')
        
def startit():
    reset_data()
    reset_players()
    arg1 = es.getargv(1)
    arg2 = es.getargv(2)
    if arg1: data['team1']['name'] = arg1
    if arg2: data['team2']['name'] = arg2
    msg('Starting war between %s and %s'%(data['team1']['name'], data['team2']['name']))
    gen_dotr()
    if int(auto_pass):
        es.server.queuecmd('sv_password "%s"'%pass_on)
    doCFG(str(precfg))

def force():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if auth(steam):
        forceit()
    else:
        es.cexec(userid, 'echo "You are not authorised!"')

def forceit():
    msg('War is being forced to start by an Admin')
    for i in players:
        players[i] = 1
    gen_dotr()

def cancel():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if auth(steam):
        cancelit()
    else:
        es.cexec(userid, 'echo "You are not authorised!"')

def cancelit():
    msg('War has been ended by admin')
    reset_data()
    stoptv()
    doCFG(str(postcfg))

def reset_data():
    global data
    data = {'active':0, 'mode':'norm', 'rActive':0,'rcount':0,'ot':0,'team1': {'name':'Team 1', 'score':0},'team2': {'name':'Team 2', 'score':0}}

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('warmod', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'warmod')
    else:
        isAuthed = lambda x: False

def auth(steam):
    if steam in admins: return 1
    return isAuthed(es.getuserid(steam))

def chatter(uid, text, teamonly):
    text = text.strip('"')
    userid = str(uid)   
    if text in ['.r', '/r', '!r', '.ready', '/ready', '!ready']:
        if data['rActive']:
            if players[userid]:
                tell(userid, 'You are already marked as ready!')
            else:
                players[userid] = 1
                tell(userid, 'You have been marked as ready!')
                gen_dotr()
        else:
            tell(userid, 'There is no active war!')
        return (0,0,0)
    
    elif text in ['.ur', '/ur', '!ur', '.unready', '/unready', '!unready']:
        if data['rActive']:
            if players[userid]:
                players[userid] = 0
                tell(userid, 'You are no longer ready!')
                gen_dotr()
            else:
                tell(userid, 'You wern\'t ready to begin with....')
        else:
            tell(userid, 'There is no active war!')
        return (0,0,0)
    elif text in ['.score', '/score', '!score']:
        if data['active']:
            if data['team1']['score'] > data['team2']['score']:
                tell(userid, '%s leads %s-%s'%(data['team1']['name'], data['team1']['score'],data['team2']['score']))
            elif data['team1']['score'] < data['team2']['score']:
                tell(userid, '%s leads %s-%s'%(data['team2']['name'], data['team2']['score'],data['team1']['score']))
            else :
                tell(userid, 'Draw -  %s-%s'%(data['team1']['score'],data['team2']['score']))
            return (0,0,0)
    elif text in ['!result', '.result', '/result']:
        msg('In the last war, %s beat %s, %s-%s'%(result['winner'], result['looser'], result['wscore'], result['lscore']))
    elif text in ['!info', '!info', '/info']:
        if data['rActive']:
            dotr.unsend(uid)
            dotr.send(uid)
            return (0,0,0)
        
    elif data['active']:
        if int(supress):
            if not int(playerlib.getPlayer(userid).attributes['isdead']):
                return (uid, text, True)
        return (uid, text, teamonly)
    
def filterPlayers():
    global players
    humans = dict(players)
    for i in humans:
        if es.getplayersteamid(i) == 'BOT':
            del players[i]
    
def gen_dotr():
    global dotr, players
    filterPlayers()
    data['rActive'] = 1
    ready = 1
    for i in players:
        dotr.unsend(i)
        if not players[i]:
            ready = 0
    if not ready:
        dotr.delete()
        dotr = popuplib.create('dotr')
        dotr.addline('      Warmod - Ready System')
        dotr.addline('--------------------------------')
        dotr.addline('        Unready Players:')
        dotr.addline('--------------------------------')
        for i in players:
            if not players[i]:
                dotr.addline(es.getplayername(i))
        dotr.addline('--------------------------------')
        dotr.addline('When your ready, say .r')
        for i in players:
            dotr.send(i)
    else:
        msg('All Players are ready!')
        msg('Automation will begin in 3 seconds!')
        data['rActive'] = 0
        gamethread.delayed(3, lo3)

def data_set(key, value):
    data[key] = value

def lo3():
    if data['mode'] == 'norm':
        text1 = 'Live'
        text2 = 'LIVE'
    elif data['mode'] == 'ot':
        text1 = 'Over Time'
        text2 = '!OT!'
    for i in range(0, 6):
          gamethread.delayed(3, msg, "%s on 3 restarts"%text1)
    gamethread.delayed(4, es.server.queuecmd, "mp_restartgame 1")
    for i in range(0, 6):
          gamethread.delayed(5, msg, "%s on 2 restarts"%text1)
    gamethread.delayed(6, es.server.queuecmd, "mp_restartgame 1")
    for i in range(0, 6):
          gamethread.delayed(7, msg, "%s Next Restart!!!"%text1)
    gamethread.delayed(8, es.server.queuecmd, "mp_restartgame 1")
    gamethread.delayed(9, msg, "*%s*------"%text2)
    gamethread.delayed(9.1, msg, "-*%s*-----"%text2)
    gamethread.delayed(9.2, msg, "--*%s*----"%text2)
    gamethread.delayed(9.3, msg, "---*%s*---"%text2)
    gamethread.delayed(9.4, msg, "----*%s*--"%text2)
    gamethread.delayed(9.5, msg, "-----*%s*-"%text2)
    gamethread.delayed(9.6, msg, "------*%s*"%text2)
    gamethread.delayed(9.7, msg, "-----*%s*-"%text2)
    gamethread.delayed(9.8, msg, "----*%s*--"%text2)
    gamethread.delayed(9.9, msg, "---*%s*---"%text2)
    gamethread.delayed(10, msg, "--*%s*----"%text2)
    gamethread.delayed(10.1, msg, "-*%s*-----"%text2)
    gamethread.delayed(10.2, msg, "*%s*------"%text2)
    gamethread.delayed(10.3, msg, "*%s*------"%text2)
    gamethread.delayed(10.4, msg, "-*%s*-----"%text2)
    gamethread.delayed(10.5, msg, "--*%s*----"%text2)
    gamethread.delayed(10.6, msg, "---*%s*---"%text2)
    gamethread.delayed(10.7, msg, "----*%s*--"%text2)
    gamethread.delayed(10.8, msg, "-----*%s*-"%text2)
    gamethread.delayed(10.9, msg, "------*%s*"%text2)
    gamethread.delayed(11, msg, "-----*%s*-"%text2)
    gamethread.delayed(11.1, msg, "----*%s*--"%text2)
    gamethread.delayed(11.2, msg, "---*%s*---"%text2)
    gamethread.delayed(11.3, msg, "---*%s*---"%text2)
    gamethread.delayed(11.4, msg, "---*%s*---"%text2)
    gamethread.delayed(11.5, msg, "---*%s*---"%text2)
    gamethread.delayed(11.5, msg, "---*%s*---"%text2)
    gamethread.delayed(11.6, msg, "Good Luck! Have Fun!")
    gamethread.delayed(12, data_set, ('active', 1))
    #gamethread.delayed(12.1, cashControl)
    if int(es.ServerVar('tv_enable')) and int(source_tv):
        filename = time.strftime("%Y-%m-%d_%H-%M", time.localtime())
        es.server.queuecmd('tv_record "warmod-%s"'%filename)

def stoptv():
    if int(es.ServerVar('tv_enable')) and int(source_tv):
        es.server.queuecmd('tv_stoprecord')
        
def bomb_defused(ev):
    if not int(objective_points):
        userid = ev['userid']
        es.server.queuecmd('score del %s 1'%userid)
    
def bomb_exploded(ev):
    if not int(objective_points):
        userid = ev['userid']
        es.server.queuecmd('score del %s 3'%userid)

def doCFG(name):
    if int(autocfg):
        es.delayed(2, 'exec %s'%name)
        